// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from automotive_navigation_msgs:msg/ModuleState.idl
// generated code does not contain a copyright notice
#include "automotive_navigation_msgs/msg/detail/module_state__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `name`
// Member `state`
// Member `info`
#include "rosidl_runtime_c/string_functions.h"

bool
automotive_navigation_msgs__msg__ModuleState__init(automotive_navigation_msgs__msg__ModuleState * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    automotive_navigation_msgs__msg__ModuleState__fini(msg);
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__init(&msg->name)) {
    automotive_navigation_msgs__msg__ModuleState__fini(msg);
    return false;
  }
  // state
  if (!rosidl_runtime_c__String__init(&msg->state)) {
    automotive_navigation_msgs__msg__ModuleState__fini(msg);
    return false;
  }
  // info
  if (!rosidl_runtime_c__String__init(&msg->info)) {
    automotive_navigation_msgs__msg__ModuleState__fini(msg);
    return false;
  }
  return true;
}

void
automotive_navigation_msgs__msg__ModuleState__fini(automotive_navigation_msgs__msg__ModuleState * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // name
  rosidl_runtime_c__String__fini(&msg->name);
  // state
  rosidl_runtime_c__String__fini(&msg->state);
  // info
  rosidl_runtime_c__String__fini(&msg->info);
}

bool
automotive_navigation_msgs__msg__ModuleState__are_equal(const automotive_navigation_msgs__msg__ModuleState * lhs, const automotive_navigation_msgs__msg__ModuleState * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->name), &(rhs->name)))
  {
    return false;
  }
  // state
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->state), &(rhs->state)))
  {
    return false;
  }
  // info
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->info), &(rhs->info)))
  {
    return false;
  }
  return true;
}

bool
automotive_navigation_msgs__msg__ModuleState__copy(
  const automotive_navigation_msgs__msg__ModuleState * input,
  automotive_navigation_msgs__msg__ModuleState * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__copy(
      &(input->name), &(output->name)))
  {
    return false;
  }
  // state
  if (!rosidl_runtime_c__String__copy(
      &(input->state), &(output->state)))
  {
    return false;
  }
  // info
  if (!rosidl_runtime_c__String__copy(
      &(input->info), &(output->info)))
  {
    return false;
  }
  return true;
}

automotive_navigation_msgs__msg__ModuleState *
automotive_navigation_msgs__msg__ModuleState__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_navigation_msgs__msg__ModuleState * msg = (automotive_navigation_msgs__msg__ModuleState *)allocator.allocate(sizeof(automotive_navigation_msgs__msg__ModuleState), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(automotive_navigation_msgs__msg__ModuleState));
  bool success = automotive_navigation_msgs__msg__ModuleState__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
automotive_navigation_msgs__msg__ModuleState__destroy(automotive_navigation_msgs__msg__ModuleState * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    automotive_navigation_msgs__msg__ModuleState__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
automotive_navigation_msgs__msg__ModuleState__Sequence__init(automotive_navigation_msgs__msg__ModuleState__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_navigation_msgs__msg__ModuleState * data = NULL;

  if (size) {
    data = (automotive_navigation_msgs__msg__ModuleState *)allocator.zero_allocate(size, sizeof(automotive_navigation_msgs__msg__ModuleState), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = automotive_navigation_msgs__msg__ModuleState__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        automotive_navigation_msgs__msg__ModuleState__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
automotive_navigation_msgs__msg__ModuleState__Sequence__fini(automotive_navigation_msgs__msg__ModuleState__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      automotive_navigation_msgs__msg__ModuleState__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

automotive_navigation_msgs__msg__ModuleState__Sequence *
automotive_navigation_msgs__msg__ModuleState__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_navigation_msgs__msg__ModuleState__Sequence * array = (automotive_navigation_msgs__msg__ModuleState__Sequence *)allocator.allocate(sizeof(automotive_navigation_msgs__msg__ModuleState__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = automotive_navigation_msgs__msg__ModuleState__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
automotive_navigation_msgs__msg__ModuleState__Sequence__destroy(automotive_navigation_msgs__msg__ModuleState__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    automotive_navigation_msgs__msg__ModuleState__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
automotive_navigation_msgs__msg__ModuleState__Sequence__are_equal(const automotive_navigation_msgs__msg__ModuleState__Sequence * lhs, const automotive_navigation_msgs__msg__ModuleState__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!automotive_navigation_msgs__msg__ModuleState__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
automotive_navigation_msgs__msg__ModuleState__Sequence__copy(
  const automotive_navigation_msgs__msg__ModuleState__Sequence * input,
  automotive_navigation_msgs__msg__ModuleState__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(automotive_navigation_msgs__msg__ModuleState);
    automotive_navigation_msgs__msg__ModuleState * data =
      (automotive_navigation_msgs__msg__ModuleState *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!automotive_navigation_msgs__msg__ModuleState__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          automotive_navigation_msgs__msg__ModuleState__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!automotive_navigation_msgs__msg__ModuleState__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
