// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from automotive_navigation_msgs:msg/PointOfInterestArray.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__POINT_OF_INTEREST_ARRAY__STRUCT_HPP_
#define AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__POINT_OF_INTEREST_ARRAY__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'point_list'
#include "automotive_navigation_msgs/msg/detail/point_of_interest__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__automotive_navigation_msgs__msg__PointOfInterestArray __attribute__((deprecated))
#else
# define DEPRECATED__automotive_navigation_msgs__msg__PointOfInterestArray __declspec(deprecated)
#endif

namespace automotive_navigation_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PointOfInterestArray_
{
  using Type = PointOfInterestArray_<ContainerAllocator>;

  explicit PointOfInterestArray_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->update_num = 0;
    }
  }

  explicit PointOfInterestArray_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->update_num = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _update_num_type =
    uint16_t;
  _update_num_type update_num;
  using _point_list_type =
    std::vector<automotive_navigation_msgs::msg::PointOfInterest_<ContainerAllocator>, typename ContainerAllocator::template rebind<automotive_navigation_msgs::msg::PointOfInterest_<ContainerAllocator>>::other>;
  _point_list_type point_list;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__update_num(
    const uint16_t & _arg)
  {
    this->update_num = _arg;
    return *this;
  }
  Type & set__point_list(
    const std::vector<automotive_navigation_msgs::msg::PointOfInterest_<ContainerAllocator>, typename ContainerAllocator::template rebind<automotive_navigation_msgs::msg::PointOfInterest_<ContainerAllocator>>::other> & _arg)
  {
    this->point_list = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    automotive_navigation_msgs::msg::PointOfInterestArray_<ContainerAllocator> *;
  using ConstRawPtr =
    const automotive_navigation_msgs::msg::PointOfInterestArray_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<automotive_navigation_msgs::msg::PointOfInterestArray_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<automotive_navigation_msgs::msg::PointOfInterestArray_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      automotive_navigation_msgs::msg::PointOfInterestArray_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<automotive_navigation_msgs::msg::PointOfInterestArray_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      automotive_navigation_msgs::msg::PointOfInterestArray_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<automotive_navigation_msgs::msg::PointOfInterestArray_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<automotive_navigation_msgs::msg::PointOfInterestArray_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<automotive_navigation_msgs::msg::PointOfInterestArray_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__automotive_navigation_msgs__msg__PointOfInterestArray
    std::shared_ptr<automotive_navigation_msgs::msg::PointOfInterestArray_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__automotive_navigation_msgs__msg__PointOfInterestArray
    std::shared_ptr<automotive_navigation_msgs::msg::PointOfInterestArray_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PointOfInterestArray_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->update_num != other.update_num) {
      return false;
    }
    if (this->point_list != other.point_list) {
      return false;
    }
    return true;
  }
  bool operator!=(const PointOfInterestArray_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PointOfInterestArray_

// alias to use template instance with default allocator
using PointOfInterestArray =
  automotive_navigation_msgs::msg::PointOfInterestArray_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace automotive_navigation_msgs

#endif  // AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__POINT_OF_INTEREST_ARRAY__STRUCT_HPP_
