// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from automotive_navigation_msgs:msg/Direction.idl
// generated code does not contain a copyright notice
#include "automotive_navigation_msgs/msg/detail/direction__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
automotive_navigation_msgs__msg__Direction__init(automotive_navigation_msgs__msg__Direction * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    automotive_navigation_msgs__msg__Direction__fini(msg);
    return false;
  }
  // direction
  return true;
}

void
automotive_navigation_msgs__msg__Direction__fini(automotive_navigation_msgs__msg__Direction * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // direction
}

bool
automotive_navigation_msgs__msg__Direction__are_equal(const automotive_navigation_msgs__msg__Direction * lhs, const automotive_navigation_msgs__msg__Direction * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // direction
  if (lhs->direction != rhs->direction) {
    return false;
  }
  return true;
}

bool
automotive_navigation_msgs__msg__Direction__copy(
  const automotive_navigation_msgs__msg__Direction * input,
  automotive_navigation_msgs__msg__Direction * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // direction
  output->direction = input->direction;
  return true;
}

automotive_navigation_msgs__msg__Direction *
automotive_navigation_msgs__msg__Direction__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_navigation_msgs__msg__Direction * msg = (automotive_navigation_msgs__msg__Direction *)allocator.allocate(sizeof(automotive_navigation_msgs__msg__Direction), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(automotive_navigation_msgs__msg__Direction));
  bool success = automotive_navigation_msgs__msg__Direction__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
automotive_navigation_msgs__msg__Direction__destroy(automotive_navigation_msgs__msg__Direction * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    automotive_navigation_msgs__msg__Direction__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
automotive_navigation_msgs__msg__Direction__Sequence__init(automotive_navigation_msgs__msg__Direction__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_navigation_msgs__msg__Direction * data = NULL;

  if (size) {
    data = (automotive_navigation_msgs__msg__Direction *)allocator.zero_allocate(size, sizeof(automotive_navigation_msgs__msg__Direction), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = automotive_navigation_msgs__msg__Direction__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        automotive_navigation_msgs__msg__Direction__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
automotive_navigation_msgs__msg__Direction__Sequence__fini(automotive_navigation_msgs__msg__Direction__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      automotive_navigation_msgs__msg__Direction__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

automotive_navigation_msgs__msg__Direction__Sequence *
automotive_navigation_msgs__msg__Direction__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_navigation_msgs__msg__Direction__Sequence * array = (automotive_navigation_msgs__msg__Direction__Sequence *)allocator.allocate(sizeof(automotive_navigation_msgs__msg__Direction__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = automotive_navigation_msgs__msg__Direction__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
automotive_navigation_msgs__msg__Direction__Sequence__destroy(automotive_navigation_msgs__msg__Direction__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    automotive_navigation_msgs__msg__Direction__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
automotive_navigation_msgs__msg__Direction__Sequence__are_equal(const automotive_navigation_msgs__msg__Direction__Sequence * lhs, const automotive_navigation_msgs__msg__Direction__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!automotive_navigation_msgs__msg__Direction__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
automotive_navigation_msgs__msg__Direction__Sequence__copy(
  const automotive_navigation_msgs__msg__Direction__Sequence * input,
  automotive_navigation_msgs__msg__Direction__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(automotive_navigation_msgs__msg__Direction);
    automotive_navigation_msgs__msg__Direction * data =
      (automotive_navigation_msgs__msg__Direction *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!automotive_navigation_msgs__msg__Direction__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          automotive_navigation_msgs__msg__Direction__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!automotive_navigation_msgs__msg__Direction__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
