// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from automotive_navigation_msgs:msg/LaneBoundary.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "automotive_navigation_msgs/msg/detail/lane_boundary__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace automotive_navigation_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void LaneBoundary_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) automotive_navigation_msgs::msg::LaneBoundary(_init);
}

void LaneBoundary_fini_function(void * message_memory)
{
  auto typed_message = static_cast<automotive_navigation_msgs::msg::LaneBoundary *>(message_memory);
  typed_message->~LaneBoundary();
}

size_t size_function__LaneBoundary__line(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<geometry_msgs::msg::Point> *>(untyped_member);
  return member->size();
}

const void * get_const_function__LaneBoundary__line(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<geometry_msgs::msg::Point> *>(untyped_member);
  return &member[index];
}

void * get_function__LaneBoundary__line(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<geometry_msgs::msg::Point> *>(untyped_member);
  return &member[index];
}

void resize_function__LaneBoundary__line(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<geometry_msgs::msg::Point> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember LaneBoundary_message_member_array[3] = {
  {
    "style",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT8,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(automotive_navigation_msgs::msg::LaneBoundary, style),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "color",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT8,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(automotive_navigation_msgs::msg::LaneBoundary, color),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "line",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<geometry_msgs::msg::Point>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(automotive_navigation_msgs::msg::LaneBoundary, line),  // bytes offset in struct
    nullptr,  // default value
    size_function__LaneBoundary__line,  // size() function pointer
    get_const_function__LaneBoundary__line,  // get_const(index) function pointer
    get_function__LaneBoundary__line,  // get(index) function pointer
    resize_function__LaneBoundary__line  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers LaneBoundary_message_members = {
  "automotive_navigation_msgs::msg",  // message namespace
  "LaneBoundary",  // message name
  3,  // number of fields
  sizeof(automotive_navigation_msgs::msg::LaneBoundary),
  LaneBoundary_message_member_array,  // message members
  LaneBoundary_init_function,  // function to initialize message memory (memory has to be allocated)
  LaneBoundary_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t LaneBoundary_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &LaneBoundary_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace automotive_navigation_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<automotive_navigation_msgs::msg::LaneBoundary>()
{
  return &::automotive_navigation_msgs::msg::rosidl_typesupport_introspection_cpp::LaneBoundary_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, automotive_navigation_msgs, msg, LaneBoundary)() {
  return &::automotive_navigation_msgs::msg::rosidl_typesupport_introspection_cpp::LaneBoundary_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
