// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from automotive_navigation_msgs:msg/PointOfInterestRequest.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__POINT_OF_INTEREST_REQUEST__STRUCT_HPP_
#define AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__POINT_OF_INTEREST_REQUEST__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__automotive_navigation_msgs__msg__PointOfInterestRequest __attribute__((deprecated))
#else
# define DEPRECATED__automotive_navigation_msgs__msg__PointOfInterestRequest __declspec(deprecated)
#endif

namespace automotive_navigation_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PointOfInterestRequest_
{
  using Type = PointOfInterestRequest_<ContainerAllocator>;

  explicit PointOfInterestRequest_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name = "";
      this->module_name = "";
      this->request_id = 0;
      this->cancel = 0;
      this->update_num = 0;
      this->guid_valid = 0;
      this->guid = 0ull;
      this->tolerance = 0.0f;
    }
  }

  explicit PointOfInterestRequest_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    name(_alloc),
    module_name(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name = "";
      this->module_name = "";
      this->request_id = 0;
      this->cancel = 0;
      this->update_num = 0;
      this->guid_valid = 0;
      this->guid = 0ull;
      this->tolerance = 0.0f;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _name_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _name_type name;
  using _module_name_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _module_name_type module_name;
  using _request_id_type =
    uint16_t;
  _request_id_type request_id;
  using _cancel_type =
    uint16_t;
  _cancel_type cancel;
  using _update_num_type =
    uint16_t;
  _update_num_type update_num;
  using _guid_valid_type =
    uint16_t;
  _guid_valid_type guid_valid;
  using _guid_type =
    uint64_t;
  _guid_type guid;
  using _tolerance_type =
    float;
  _tolerance_type tolerance;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__name(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->name = _arg;
    return *this;
  }
  Type & set__module_name(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->module_name = _arg;
    return *this;
  }
  Type & set__request_id(
    const uint16_t & _arg)
  {
    this->request_id = _arg;
    return *this;
  }
  Type & set__cancel(
    const uint16_t & _arg)
  {
    this->cancel = _arg;
    return *this;
  }
  Type & set__update_num(
    const uint16_t & _arg)
  {
    this->update_num = _arg;
    return *this;
  }
  Type & set__guid_valid(
    const uint16_t & _arg)
  {
    this->guid_valid = _arg;
    return *this;
  }
  Type & set__guid(
    const uint64_t & _arg)
  {
    this->guid = _arg;
    return *this;
  }
  Type & set__tolerance(
    const float & _arg)
  {
    this->tolerance = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    automotive_navigation_msgs::msg::PointOfInterestRequest_<ContainerAllocator> *;
  using ConstRawPtr =
    const automotive_navigation_msgs::msg::PointOfInterestRequest_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<automotive_navigation_msgs::msg::PointOfInterestRequest_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<automotive_navigation_msgs::msg::PointOfInterestRequest_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      automotive_navigation_msgs::msg::PointOfInterestRequest_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<automotive_navigation_msgs::msg::PointOfInterestRequest_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      automotive_navigation_msgs::msg::PointOfInterestRequest_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<automotive_navigation_msgs::msg::PointOfInterestRequest_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<automotive_navigation_msgs::msg::PointOfInterestRequest_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<automotive_navigation_msgs::msg::PointOfInterestRequest_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__automotive_navigation_msgs__msg__PointOfInterestRequest
    std::shared_ptr<automotive_navigation_msgs::msg::PointOfInterestRequest_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__automotive_navigation_msgs__msg__PointOfInterestRequest
    std::shared_ptr<automotive_navigation_msgs::msg::PointOfInterestRequest_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PointOfInterestRequest_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->name != other.name) {
      return false;
    }
    if (this->module_name != other.module_name) {
      return false;
    }
    if (this->request_id != other.request_id) {
      return false;
    }
    if (this->cancel != other.cancel) {
      return false;
    }
    if (this->update_num != other.update_num) {
      return false;
    }
    if (this->guid_valid != other.guid_valid) {
      return false;
    }
    if (this->guid != other.guid) {
      return false;
    }
    if (this->tolerance != other.tolerance) {
      return false;
    }
    return true;
  }
  bool operator!=(const PointOfInterestRequest_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PointOfInterestRequest_

// alias to use template instance with default allocator
using PointOfInterestRequest =
  automotive_navigation_msgs::msg::PointOfInterestRequest_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace automotive_navigation_msgs

#endif  // AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__POINT_OF_INTEREST_REQUEST__STRUCT_HPP_
