// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from automotive_navigation_msgs:msg/PointOfInterestResponse.idl
// generated code does not contain a copyright notice
#include "automotive_navigation_msgs/msg/detail/point_of_interest_response__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `name`
// Member `module_name`
#include "rosidl_runtime_c/string_functions.h"
// Member `point_statuses`
#include "automotive_navigation_msgs/msg/detail/point_of_interest_status__functions.h"

bool
automotive_navigation_msgs__msg__PointOfInterestResponse__init(automotive_navigation_msgs__msg__PointOfInterestResponse * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    automotive_navigation_msgs__msg__PointOfInterestResponse__fini(msg);
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__init(&msg->name)) {
    automotive_navigation_msgs__msg__PointOfInterestResponse__fini(msg);
    return false;
  }
  // module_name
  if (!rosidl_runtime_c__String__init(&msg->module_name)) {
    automotive_navigation_msgs__msg__PointOfInterestResponse__fini(msg);
    return false;
  }
  // request_id
  // update_num
  // point_statuses
  if (!automotive_navigation_msgs__msg__PointOfInterestStatus__Sequence__init(&msg->point_statuses, 0)) {
    automotive_navigation_msgs__msg__PointOfInterestResponse__fini(msg);
    return false;
  }
  return true;
}

void
automotive_navigation_msgs__msg__PointOfInterestResponse__fini(automotive_navigation_msgs__msg__PointOfInterestResponse * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // name
  rosidl_runtime_c__String__fini(&msg->name);
  // module_name
  rosidl_runtime_c__String__fini(&msg->module_name);
  // request_id
  // update_num
  // point_statuses
  automotive_navigation_msgs__msg__PointOfInterestStatus__Sequence__fini(&msg->point_statuses);
}

bool
automotive_navigation_msgs__msg__PointOfInterestResponse__are_equal(const automotive_navigation_msgs__msg__PointOfInterestResponse * lhs, const automotive_navigation_msgs__msg__PointOfInterestResponse * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->name), &(rhs->name)))
  {
    return false;
  }
  // module_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->module_name), &(rhs->module_name)))
  {
    return false;
  }
  // request_id
  if (lhs->request_id != rhs->request_id) {
    return false;
  }
  // update_num
  if (lhs->update_num != rhs->update_num) {
    return false;
  }
  // point_statuses
  if (!automotive_navigation_msgs__msg__PointOfInterestStatus__Sequence__are_equal(
      &(lhs->point_statuses), &(rhs->point_statuses)))
  {
    return false;
  }
  return true;
}

bool
automotive_navigation_msgs__msg__PointOfInterestResponse__copy(
  const automotive_navigation_msgs__msg__PointOfInterestResponse * input,
  automotive_navigation_msgs__msg__PointOfInterestResponse * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__copy(
      &(input->name), &(output->name)))
  {
    return false;
  }
  // module_name
  if (!rosidl_runtime_c__String__copy(
      &(input->module_name), &(output->module_name)))
  {
    return false;
  }
  // request_id
  output->request_id = input->request_id;
  // update_num
  output->update_num = input->update_num;
  // point_statuses
  if (!automotive_navigation_msgs__msg__PointOfInterestStatus__Sequence__copy(
      &(input->point_statuses), &(output->point_statuses)))
  {
    return false;
  }
  return true;
}

automotive_navigation_msgs__msg__PointOfInterestResponse *
automotive_navigation_msgs__msg__PointOfInterestResponse__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_navigation_msgs__msg__PointOfInterestResponse * msg = (automotive_navigation_msgs__msg__PointOfInterestResponse *)allocator.allocate(sizeof(automotive_navigation_msgs__msg__PointOfInterestResponse), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(automotive_navigation_msgs__msg__PointOfInterestResponse));
  bool success = automotive_navigation_msgs__msg__PointOfInterestResponse__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
automotive_navigation_msgs__msg__PointOfInterestResponse__destroy(automotive_navigation_msgs__msg__PointOfInterestResponse * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    automotive_navigation_msgs__msg__PointOfInterestResponse__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
automotive_navigation_msgs__msg__PointOfInterestResponse__Sequence__init(automotive_navigation_msgs__msg__PointOfInterestResponse__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_navigation_msgs__msg__PointOfInterestResponse * data = NULL;

  if (size) {
    data = (automotive_navigation_msgs__msg__PointOfInterestResponse *)allocator.zero_allocate(size, sizeof(automotive_navigation_msgs__msg__PointOfInterestResponse), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = automotive_navigation_msgs__msg__PointOfInterestResponse__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        automotive_navigation_msgs__msg__PointOfInterestResponse__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
automotive_navigation_msgs__msg__PointOfInterestResponse__Sequence__fini(automotive_navigation_msgs__msg__PointOfInterestResponse__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      automotive_navigation_msgs__msg__PointOfInterestResponse__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

automotive_navigation_msgs__msg__PointOfInterestResponse__Sequence *
automotive_navigation_msgs__msg__PointOfInterestResponse__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_navigation_msgs__msg__PointOfInterestResponse__Sequence * array = (automotive_navigation_msgs__msg__PointOfInterestResponse__Sequence *)allocator.allocate(sizeof(automotive_navigation_msgs__msg__PointOfInterestResponse__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = automotive_navigation_msgs__msg__PointOfInterestResponse__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
automotive_navigation_msgs__msg__PointOfInterestResponse__Sequence__destroy(automotive_navigation_msgs__msg__PointOfInterestResponse__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    automotive_navigation_msgs__msg__PointOfInterestResponse__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
automotive_navigation_msgs__msg__PointOfInterestResponse__Sequence__are_equal(const automotive_navigation_msgs__msg__PointOfInterestResponse__Sequence * lhs, const automotive_navigation_msgs__msg__PointOfInterestResponse__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!automotive_navigation_msgs__msg__PointOfInterestResponse__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
automotive_navigation_msgs__msg__PointOfInterestResponse__Sequence__copy(
  const automotive_navigation_msgs__msg__PointOfInterestResponse__Sequence * input,
  automotive_navigation_msgs__msg__PointOfInterestResponse__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(automotive_navigation_msgs__msg__PointOfInterestResponse);
    automotive_navigation_msgs__msg__PointOfInterestResponse * data =
      (automotive_navigation_msgs__msg__PointOfInterestResponse *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!automotive_navigation_msgs__msg__PointOfInterestResponse__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          automotive_navigation_msgs__msg__PointOfInterestResponse__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!automotive_navigation_msgs__msg__PointOfInterestResponse__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
