// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from automotive_navigation_msgs:msg/PointOfInterestStatus.idl
// generated code does not contain a copyright notice
#include "automotive_navigation_msgs/msg/detail/point_of_interest_status__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `params`
#include "rosidl_runtime_c/string_functions.h"

bool
automotive_navigation_msgs__msg__PointOfInterestStatus__init(automotive_navigation_msgs__msg__PointOfInterestStatus * msg)
{
  if (!msg) {
    return false;
  }
  // guid
  // distance
  // heading
  // x_position
  // y_position
  // params
  if (!rosidl_runtime_c__String__init(&msg->params)) {
    automotive_navigation_msgs__msg__PointOfInterestStatus__fini(msg);
    return false;
  }
  return true;
}

void
automotive_navigation_msgs__msg__PointOfInterestStatus__fini(automotive_navigation_msgs__msg__PointOfInterestStatus * msg)
{
  if (!msg) {
    return;
  }
  // guid
  // distance
  // heading
  // x_position
  // y_position
  // params
  rosidl_runtime_c__String__fini(&msg->params);
}

bool
automotive_navigation_msgs__msg__PointOfInterestStatus__are_equal(const automotive_navigation_msgs__msg__PointOfInterestStatus * lhs, const automotive_navigation_msgs__msg__PointOfInterestStatus * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // guid
  if (lhs->guid != rhs->guid) {
    return false;
  }
  // distance
  if (lhs->distance != rhs->distance) {
    return false;
  }
  // heading
  if (lhs->heading != rhs->heading) {
    return false;
  }
  // x_position
  if (lhs->x_position != rhs->x_position) {
    return false;
  }
  // y_position
  if (lhs->y_position != rhs->y_position) {
    return false;
  }
  // params
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->params), &(rhs->params)))
  {
    return false;
  }
  return true;
}

bool
automotive_navigation_msgs__msg__PointOfInterestStatus__copy(
  const automotive_navigation_msgs__msg__PointOfInterestStatus * input,
  automotive_navigation_msgs__msg__PointOfInterestStatus * output)
{
  if (!input || !output) {
    return false;
  }
  // guid
  output->guid = input->guid;
  // distance
  output->distance = input->distance;
  // heading
  output->heading = input->heading;
  // x_position
  output->x_position = input->x_position;
  // y_position
  output->y_position = input->y_position;
  // params
  if (!rosidl_runtime_c__String__copy(
      &(input->params), &(output->params)))
  {
    return false;
  }
  return true;
}

automotive_navigation_msgs__msg__PointOfInterestStatus *
automotive_navigation_msgs__msg__PointOfInterestStatus__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_navigation_msgs__msg__PointOfInterestStatus * msg = (automotive_navigation_msgs__msg__PointOfInterestStatus *)allocator.allocate(sizeof(automotive_navigation_msgs__msg__PointOfInterestStatus), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(automotive_navigation_msgs__msg__PointOfInterestStatus));
  bool success = automotive_navigation_msgs__msg__PointOfInterestStatus__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
automotive_navigation_msgs__msg__PointOfInterestStatus__destroy(automotive_navigation_msgs__msg__PointOfInterestStatus * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    automotive_navigation_msgs__msg__PointOfInterestStatus__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
automotive_navigation_msgs__msg__PointOfInterestStatus__Sequence__init(automotive_navigation_msgs__msg__PointOfInterestStatus__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_navigation_msgs__msg__PointOfInterestStatus * data = NULL;

  if (size) {
    data = (automotive_navigation_msgs__msg__PointOfInterestStatus *)allocator.zero_allocate(size, sizeof(automotive_navigation_msgs__msg__PointOfInterestStatus), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = automotive_navigation_msgs__msg__PointOfInterestStatus__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        automotive_navigation_msgs__msg__PointOfInterestStatus__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
automotive_navigation_msgs__msg__PointOfInterestStatus__Sequence__fini(automotive_navigation_msgs__msg__PointOfInterestStatus__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      automotive_navigation_msgs__msg__PointOfInterestStatus__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

automotive_navigation_msgs__msg__PointOfInterestStatus__Sequence *
automotive_navigation_msgs__msg__PointOfInterestStatus__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_navigation_msgs__msg__PointOfInterestStatus__Sequence * array = (automotive_navigation_msgs__msg__PointOfInterestStatus__Sequence *)allocator.allocate(sizeof(automotive_navigation_msgs__msg__PointOfInterestStatus__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = automotive_navigation_msgs__msg__PointOfInterestStatus__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
automotive_navigation_msgs__msg__PointOfInterestStatus__Sequence__destroy(automotive_navigation_msgs__msg__PointOfInterestStatus__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    automotive_navigation_msgs__msg__PointOfInterestStatus__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
automotive_navigation_msgs__msg__PointOfInterestStatus__Sequence__are_equal(const automotive_navigation_msgs__msg__PointOfInterestStatus__Sequence * lhs, const automotive_navigation_msgs__msg__PointOfInterestStatus__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!automotive_navigation_msgs__msg__PointOfInterestStatus__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
automotive_navigation_msgs__msg__PointOfInterestStatus__Sequence__copy(
  const automotive_navigation_msgs__msg__PointOfInterestStatus__Sequence * input,
  automotive_navigation_msgs__msg__PointOfInterestStatus__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(automotive_navigation_msgs__msg__PointOfInterestStatus);
    automotive_navigation_msgs__msg__PointOfInterestStatus * data =
      (automotive_navigation_msgs__msg__PointOfInterestStatus *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!automotive_navigation_msgs__msg__PointOfInterestStatus__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          automotive_navigation_msgs__msg__PointOfInterestStatus__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!automotive_navigation_msgs__msg__PointOfInterestStatus__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
